<?php
namespace Models;

class php_shtrihm_Fr_php {
  public $f3, $sets, $config, $port, $kkm;

  function __construct($f3, $sets, $config) {
    $this->f3=$f3;
    $this->sets=$sets;
    require_once $sets['driver'].'/KKM.ports.php';
    require_once $sets['driver'].'/KKM.class.php';
    $this->config=$config;
    //$this->config=parse_ini_file($sets['driver'].'/server.config'); // Настройки драйвера
    $this->config['PortType']=strtolower($this->config['PortType']);
    if($this->config['PortType']=='remote') {
      $sets['url']=mb_substr($sets['url'], mb_strrpos($sets['url'], '/')+1);
      $url=explode(':', $sets['url']);
      $host = $url[0];
      $port = $url[1];
      $this->port = new \RemotePort($host, $port);
    }
    elseif($this->config['PortType']=='socket') {
      $sets['url']=mb_substr($sets['url'], mb_strrpos($sets['url'], '/')+1);
      $url=explode(':', $sets['url']);
      $host = $url[0];
      $port = $url[1];
      $this->port = new \RemoteSocket($host, $port);
    }
    elseif($this->config['PortType']=='ssh') {
      $u=mb_substr($sets['url'], mb_strrpos($sets['url'], '/'));
      $url=explode(':', $u);
      $host = $url[0];
      $port = $url[1];
      $this->port = new \SshComPort($host, $port);
    }
    else {
      $this->port = new \LocalComPort($sets['url']);
    }
    require_once $this->sets['driver'].'/Shtrih.lang.php';
    require_once $this->sets['driver'].'/ShtrihM_HiLevel.class.php';
    $this->kkm= new \ShtrihM_HiLevel($this->port, false, $sets);
    $this->kkm->paper_width=$this->config['PaperWidth'];
    if($this->config['AlwaysExec']) {
      $this->always_exec($this->config['AlwaysExec']);
    }
  }

  function always_exec($exec) {
    foreach ($exec as $cmd) {
      if($cmd!='') {
        exec($cmd);
      }
    }
  }

  function kkm_init() {
    if($this->kkm->kkm_init()) {
      $this->f3->set('SESSION.'.$this->sets['printer'].'_drivers_init', 1);
    }
    else {
      echo '<p class="false">Ошибка инициализации ККМ</p>';
            exit();
    }
  }

  // Узнаем состояние смены
    function change_status() {
      if(!$this->f3->get('SESSION.'.$this->sets['printer'].'_drivers_init')) {
      $this->kkm_init();
    }
      if(!$this->kkm->openConnection()) {
            echo '<p class="false">Не возможно установить соединение с кассой</p>';
            exit();
        }
        $status='closed';
        $s=$this->kkm->getKKMState();
        if($s['fr_mode']==3) {
          $status='expired';
        }
        if($s['fr_mode']==2) {
          $status='opened';
        }
        $this->kkm->closeConnection();
        return $status;
    }

  // Отправка запроса
  function send_ajax($data, $timeout=295, $view=false) {
    if(!$this->f3->get('SESSION.'.$this->sets['printer'].'_drivers_init')) {
      $this->kkm_init();
    }
    $strs=explode("\n", $data);
        if(!$this->kkm->openConnection()) {
            if($this->f3->get('fr_error_ignore')) {
                  return array(
                    'success'=>false,
                    'error'=>'Не возможно установить соединение с кассой'
                  );
              }
            echo '<p class="false">Не возможно установить соединение с кассой</p>';
            exit();
        }

        $counter=30;
        while (!$this->kkm->isReady() && $counter>0) {
            $counter-=1;
            sleep(1);
        }
        $error=false;
        $print_b=0;
      foreach ($strs as $s) {
        $ss=explode(';', $s);
        if($ss[0]=='b' || $ss[0]=='z' || $ss[0]=='imde' || $ss[0]=='open_session') {
          $print_b=1;
        }
        if(!$s) continue;
        $res=$this->kkm->wtf($s);
            if($res==='nak') {
                $res=$this->kkm->wtf($s);
            }

            if($res==='nak') {
                $error=true;
                $error_txt=$s.'<p>Ошибка интерфейса</p>';
            }
            elseif($res===false) {
                $error=true;
                $error_txt='Касса в данный момент недоступна';
            }
            elseif(is_array($res)) {
              if(isset($res['success'])) {
                continue;
              }
              $error=true;
                $error_txt=$s.' '.$res['code'].' '.$res['txt'];
            }

            if($error===true) {

              if($this->f3->get('fr_error_ignore')) {
                  return array(
                    'success'=>false,
                    'error'=>$error_txt
                  );
              }
                echo '<p class="false">'.$error_txt.'</p>';
                if($print_b==1 || (is_array($res) && $res['code']=='107')) {
                  echo $continue_html= \Template::instance()->render('fr_error_continue_print.htm');
                  exit();
                }
                exit();
            }
            //$receipt_ready=$this->kkm->receipt_ready;
      }
      $this->kkm->closeConnection();
    if($view===true) {
      //var_dump($this->kkm->msg);
      foreach ($this->kkm->results as $txt) {
        echo '<p class="'.($txt[0]?'true':'false').'">'.$txt['txt'].'</p>';
      }
    }
    if($this->kkm->fd!=0 && $this->kkm->fp!=0) {
      $res=array(
        'success'=>true,
        'fd'=>$this->kkm->fd,
        'fp'=>$this->kkm->fp
      );
    }
    return $res;
  }
}
